﻿var io = 0;
var selector = "#DeafServicePlace";
var ItemToAdd = null;
var addBefore = false;
var MrBackColor = "#D3B980";
var MrTextColor = "#FFFFFF";
var DeafIconPattle = "deaficon.png";
var MrBotMarg = 35;

var ArWelcomeMsg = "أهلا وسهلا حرك المؤشر على الجملة وأنا أترجم";
var EnWelcomeMsg = "Move Pointer over sentence and I translate";
var ArAvatarWelcomeMsg = "أهلا وسهلا حرك المؤشر على الجملة وأنا أترجم";
var EnAvatarWelcomeMsg = "Move Pointer over sentence and I translate";
var ArBotWelcomeMsg =
  "أهلا بك في تـشات بـوت , تستطيع استخدام رمز اليد للترجمة او استخدام المترجم التلقائي من خلال زر التشغيل";
var EnBotWelcomeMsg =
  "Welcome to chatbot , you can either use the hand sign to interpret a sentince or use the play button for automatic mode";

var ArContMsg = "حرك المؤشر الان";
var EnContMsg = "Move pointer now";
var MrUse3DIntegration = true;
var SiteLang = true;

// Chatbot Variables
var MrTranslatePipeLine = [];
var mrSequenceBtns = [];
var MrIsInTranslate = false;
var mrFirstTime = true;
const MrElementsToInclude =
  ".chat-message,.chat-message--content,.buttons-container";
var mrSequenceBtns = [];
var MrIsInTranslate = false;
var mrFirstTime = true;
var MrOutputTimeout = undefined;
var MrArabotSlon = false;
// End Chatbot Variables

//// Chatbot Functions
function MrHandlePipelineElement(felm, mrMinipulateClass, mrTobeAddedClass) {
  var elm = $(felm).parent().find(mrMinipulateClass);

  $(elm).each(function () {
    $(this).addClass(mrTobeAddedClass);
    MrTranslateInPipeLine($(this));
  });
}
function MrGetArabotWindow() {
  return $(document.getElementById("arabot-webchat-wrapper").shadowRoot).find(
    "#app"
  );
}
function MrProcessInterpretedElement(emt) {
  var elemnt = emt;
  var MrAddInline = false;
  if (
    $(emt).find(".MRDivIcon").length > 0 ||
    $(emt).parent().find(".MRDivIcon").length > 0
  ) {
    return;
  }
  if ($(emt).find(">.chat-message--bg").length > 0) {
    elemnt = $(emt).parent()[0];
    MrAddInline = true;
  }
  var anc = document.createElement("a");

  $(anc).attr("href", "#");
  $(anc).text("");
  $(anc).attr("mr-skip", 1);
  // $(anc).css('float','left');
  $(anc).addClass("mr-interp-btn");
  $(anc).addClass("MRDivIcon");
  if (MrAddInline == true) {
    $(anc).addClass("mr-inline");
  }

  $(anc).click(function () {
    MrTranslatePipeLine = [];

    if ($(this).parent().find(".mr-interp-btn").length > 1) {
      $(this).parent().find(".mr-interp-btn:last").click();
      return;
    }
    var MrNode = MrGetArabotWindow();
    $(MrNode).find(".mr-translate-text").removeClass("mr-translate-text");
    $(MrNode).find(".mr-translate-list").removeClass("mr-translate-list");
    $(MrNode).find(".mr-translate-btn").removeClass("mr-translate-btn");

    MrHandlePipelineElement(this, ".chat-message--text", "mr-translate-text");
    MrHandlePipelineElement(this, ".card-title", "mr-translate-text");
    MrHandlePipelineElement(this, ".list-group-item", "mr-translate-list");
    MrHandlePipelineElement(this, ".chat-btn", "mr-translate-btn");
  });
  if (MrAddInline) {
    elemnt.append(anc);
  } else {
    elemnt.prepend(anc);
  }
  mrSequenceBtns = MrGetArabotWindow().find(".mr-interp-btn");
  $.each(mrSequenceBtns, function (i, val) {
    $(this).attr("mr-Btni", i);
    if (jQuery(".mr-cont-tooltip-window").length != 0) {
      $(this).removeClass("mr-interpbuttonHide");
    } else {
      $(this).addClass("mr-interpbuttonHide");
    }
  });
  mrPlaySequence();
}

function MrStartArabotSl() {
  if (mrPlayerisOn()) {
    $("#TranslateStop").click();
  }

  if (!MrArabotSlon) {
    MrInitNavSLPlayer();

    MrArabotSlon = true;
    SiteLang = true;
    if (SiteLang) {
      MrSetWelcomeMessage(ArBotWelcomeMsg);
    } else {
      MrSetWelcomeMessage(EnBotWelcomeMsg);
    }
    TranslateWebsite();

    MrGetArabotWindow().find(".chat--wrapper").css("z-index", 99999);
    $.each(mrSequenceBtns, function (i, val) {
      $(this).removeClass("mr-interpbuttonHide");
    });
    if (mrFirstTime) {
      const MrtargetNode = MrGetArabotWindow()[0];
      MrPrepareElementCSS(MrtargetNode);
      var ElementsRelated = $(MrtargetNode).find(MrElementsToInclude);
      $(ElementsRelated).each(function () {
        $(this).addClass("mr-translate-chat");

        MrProcessInterpretedElement(this);
      });
      const config = { attributes: true, childList: true, subtree: true };
      const callback = (mutationList, observer) => {
        for (const mutation of mutationList) {
          if (mutation.type === "childList") {
            var ElementsRelated = $(mutation.target).find(MrElementsToInclude);
            $(ElementsRelated).each(function () {
              $(this).addClass("mr-translate-chat");

              MrProcessInterpretedElement(this);
            });
          } else if (mutation.type === "attributes") {
          }
        }
      };
      const observer = new MutationObserver(callback);
      observer.observe(MrtargetNode, config);
      mrFirstTime = false;
    }
    jQuery("#TranslateStop").click(function () {
      $.each(mrSequenceBtns, function (i, val) {
        $(this).addClass("mr-interpbuttonHide");
      });
      MrArabotSlon = false;
      mrCurrentIndex = 0;
      MrGetArabotWindow()
        .find(".mr-in-translate")
        .removeClass("mr-in-translate");
      if (mrClickCloseArabot) {
        try {
          MrGetArabotWindow().find(".sign-lang")[0].click();
        } catch {}
      }
      mrClickCloseArabot = true;
    });
  }
}

function MrTranslateTextInternalWithTimeout(tx) {
  if (MrOutputTimeout != undefined) {
    clearTimeout(MrOutputTimeout);
  }
  MrOutputTimeout = setTimeout(function () {
    MrIsInTranslate = false;
    console.log("fail over is under process");
  }, tx.length * 100);
  MrTranslateTextInternal(tx);
}
function MrProcessElement(elm) {
  MrGetArabotWindow().find(".mr-in-translate").removeClass("mr-in-translate");
  if ($(elm).hasClass("mr-translate-text")) {
    $(elm).removeClass("mr-translate-text");
    var txt = $(elm).text();
    MrTranslateTextInternalWithTimeout(txt);
  } else {
    if ($(elm).hasClass("mr-translate-list")) {
      $(elm).removeClass("mr-translate-list");
      var txt = $(elm).text();
      MrTranslateTextInternalWithTimeout(txt);
    } else {
      if ($(elm).hasClass("mr-translate-btn")) {
        $(elm).removeClass("mr-translate-btn");
        var txt = $(elm).text();
        MrTranslateTextInternalWithTimeout(txt);
      } else {
        MrIsInTranslate = false;
      }
    }
  }
  $(elm).addClass("mr-in-translate");
}
function MrTranslateInPipeLine(elm) {
  if (MrIsInTranslate) {
    MrTranslatePipeLine.push(elm);
  } else {
    MrProcessElement(elm);
    MrIsInTranslate = true;
  }
}

function MrPrepareElementCSS(elm) {
  $(elm).append(
    '<style> .mr-in-translate {    background-color: lightgray !important;    color: black !important;} .mr-interpbuttonHide {display:none !important} a.mr-interp-btn.mr-inline{    margin: 5px;width:30px!important;} a.mr-interp-btn { /* float: left; */ align-items: center; width: 100%; text-align: center;display:block; } .MRDivIcon{ background-image: url("https://mindrockets.org/central/imgs/hands-solid.svg");height:30px;width:30px ;    background-repeat: no-repeat; background-position: center; ;margin-bottom: 5px;}</style>'
  );
}

var mrClickCloseArabot = true;
function MrStopArabotSl() {
  mrClickCloseArabot = false;
  jQuery("#TranslateStop").click();
}

function mrisMobileDevice() {
  const userAgent = navigator.userAgent;
  return /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
    userAgent
  );
}

function mrPlayerisOn() {
  return jQuery(".mr-cont-tooltip-window").length == 1;
}
//// End Chatbot Functions

function TranslateWebsite() {
  if (MrArabotSlon) {
    addEventListener("message", function (e) {
      if(MrArabotSlon){
      if (e.origin.indexOf("mindrockets") > -1) {
        //console.log('done translate');
        if (MrTranslatePipeLine.length > 0) {
          var MrTex = MrTranslatePipeLine.shift();
          MrProcessElement(MrTex);
        } else {
          console.log("done translate");
          MrIsInTranslate = false;
          MrGetArabotWindow()
            .find(".mr-in-translate")
            .removeClass("mr-in-translate");
          if (mrInLoopPlay) {
            mrCurrentIndex++;
            mrPlaySequenceBtn();
          }
        }
      }
      }
    });

    MrSetDisableHovering();
  } else {
    MrDisableHovering = false;
    SiteLang = jQuery("html").attr("lang").toLowerCase() == "AR".toLowerCase();
    if (!SiteLang) {
      MrSetWelcomeMessage(EnAvatarWelcomeMsg);
    } else {
      MrSetWelcomeMessage(ArAvatarWelcomeMsg);
    }
  }

  SetSourceLabel();
  if (MrUse3DIntegration) {
    ItemURL =
      "https://mindrocketsapis.com/web/TranslateJSWithLabel3D.aspx?r={0}&render=1";

    MRSetDisplayAvatar("MajedPlus_3.9.5");
    MrUseRealtimeEngine = true;
  } else {
    ItemURL =
      "https://mindrocketsapis.com/web/TranslateJSWithLabelBoosted.aspx?r={0}&render=1";
  }
  jQuery("#DeafTranslate").hide();
  var CSSClassName = "mr-tooltip";
  var commonSelectors =
    "a,h3,h2,h1,li,p,.excerpt,.text,.title,.links,.ad-content,.copyright-text,.strip,strong";
  var IgnoredChild = "br,img,strong,span,a";

  jQuery("div").each(function () {
    if (
      (jQuery(this).children().length == 0 && jQuery(this).text().length > 0) ||
      jQuery(this).children().length == jQuery(this).find(IgnoredChild).length
    ) {
      jQuery(this).addClass(CSSClassName);
    }
  });

  SplitLongElements(CSSClassName, commonSelectors, IgnoredChild);
  SplitLongElements(CSSClassName, commonSelectors, IgnoredChild);
  jQuery(".dfwp-item").removeClass(CSSClassName);
  var mrSlCid = 0;

  if (window.location.href.includes("acdn.arabot.io")) {
    mrSlCid = 13454;
  } else {
    mrSlCid = 13453;
  }
  MrPreConfigTooltip(
    MRTooltipWidth,
    MRTooltipHeight,
    MRAVSpeed,
    "KSA/SanadPlus73D",
    Lang,
    "EN",
    mrSlCid
  );
  var leftPx = 90;
  if(mrisMobileDevice()){
    leftPx = 30;
  }
  if (MrArabotSlon) {
    var windowWidth = $(window).width();
    if (mrisMobileDevice()) {
      leftPx = 70;
    } else {
      leftPx =
        windowWidth - MrGetArabotWindow().find(".chat-body").width() - 290;
    }
  }
  MRTranslatorPrepareCSS(
    ".mr-cont-tooltip-window{        position: fixed;      bottom: 15px;        left: " +
      leftPx +
      "px;    z-index:10000000000;}\r\n.mr-tooltip{  } .Highlite{background-color:#e7e8e9;}"
  );

  SetCallBackAfterAddCSSClassToChildren(function () {
    jQuery(".menu.nav.mr-tooltip>li").addClass("mr-tooltip");
    jQuery(".menu.nav.mr-tooltip>li>a#DeafTranslate")
      .parent()
      .removeClass("mr-tooltip");
    jQuery(".menu.nav.mr-tooltip").removeClass("mr-tooltip");
    jQuery("#block-menu-menu-top-menu").removeClass("mr-tooltip");
  });

  MrInitTooltip("body");
  if (MrUse3DIntegration) {
    MrScaleMax = 1.8;
    setTimeout(function () {
      MrSLIconFilter =
        " brightness(0) saturate(100%) invert(30%) sepia(8%) saturate(151%) hue-rotate(181deg) brightness(91%) contrast(89%)";
      MrScaleMax = 1.8;
      MrLoadAdvanceAvatarWindow();
    }, 200);
  }
  try {
    if (!MrArabotSlon) {
      SetParam("DeafUser", "use");
    }
  } catch (e) {}
}

var MrIinitPlugin = function () {
  MRTooltipHeight = 260;
  MRTooltipWidth = 260;
  if (typeof MrSetWelcomeMessage == "undefined") {
    setTimeout(MrIinitPlugin, 1000);
    return;
  }
  
  jQuery("body").append(
    '<div id="DeafServicePlace"></div><style>div#DeafServicePlace { cursor: pointer;   width:64px;    height: 64px;    position: fixed;   bottom:90px;   background: ' +
      MrBackColor +
      ";    padding-bottom: 6px;    border-radius: 50%;right: 15px;z-index:1000000000;}</style>"
  );

  var MrSignLanguageButtonText = "Sign Language";
  SiteLang = jQuery("html").attr("lang").toLowerCase() == "AR".toLowerCase();

  if (!SiteLang) {
    MrSetWelcomeMessage(EnContMsg);
    //english
    //   selector = "#menu-top-menu";
    MrSignLanguageButtonText = "Sign Language";
    ItemToAdd =
      '<div  id="DeafTranslate" title="' +
      MrSignLanguageButtonText +
      '" style="    margin: 5px;    color: ' +
      MrTextColor +
      ';" ><div style="text-align:center;"><img src="https://cdn.mindrocketsapis.com/client/imgs/' +
      DeafIconPattle +
      '"  width="35" style="margin-top:9px" /> </div></div>';
  } else {
    MrSetWelcomeMessage(ArContMsg);
    MrSignLanguageButtonText = "لغة الإشارة";
    //  selector = "#menu-top-menu-ar";
    //  ItemToAdd = '<li class="menu-item menu-item-type-post_type menu-item-object-page"><a id="DeafTranslate" href="javascript:void(0);"> <img src="https://cdn.mindrocketsapis.com/client/imgs/deaficon.png" width="15" />نسخة الصم</a></li>';
    ItemToAdd =
      '<div  id="DeafTranslate" title="' +
      MrSignLanguageButtonText +
      '"  style="    margin: 5px;    color: ' +
      MrTextColor +
      ';"><div style="text-align:center;"><img src="https://cdn.mindrocketsapis.com/client/imgs/' +
      DeafIconPattle +
      '" width="35" style="margin-top:9px"  /> </div></div>';
  }
  if (jQuery(selector).length <= 0) {
    console.log("child was not found");
  }
  if (addBefore) {
    jQuery(selector).prepend(ItemToAdd);
  } else {
    jQuery(selector).append(ItemToAdd);
  }
  jQuery("body").append("<style> #mr_sign_player999{ }</style>");
  jQuery("#DeafTranslate").click(function () {
    SiteLang = jQuery("html").attr("lang").toLowerCase() == "AR".toLowerCase();
    if (!SiteLang) {
      MrSetWelcomeMessage(EnAvatarWelcomeMsg);
    } else {
      MrSetWelcomeMessage(ArAvatarWelcomeMsg);
    }
    MrArabotSlon = false;
    TranslateWebsite();
  });

  try {
    if (GetParam("DeafUser") == "use") {
      if (!MrArabotSlon) {
       // jQuery("#DeafTranslate").click();
      }
    }
  } catch (e) {}
  console.log("Sign Language Widget is started");
};

window.addEventListener("load", function () {
  MrIinitPlugin();
  MrPrepareElementCSS("body");
});

// Player Script
const MrMUISecoundryColorCustom = MrBackColor;
const MrMUIPrimaryColorCustom = "#F5F5F5";
const MrMUIWhiteCustom = "#FFFFFF";
const MrMUIBlackCustom = "#000000";
const MrmainappendOnCustom = ".mr-cont-tooltip-window";
var MrVisibleElementsIndex = 0;
var MrVisibleElements = [];

var mrMainPalyerClassCustom = ".MrNavSLDiv";
function MrInitNavSLPlayer() {
  jQuery(mrMainPalyerClassCustom).remove();
  if (jQuery(mrMainPalyerClassCustom).length == 0) {
    var font = new FontFace(
      "MrMaterialSl Icons",
      "url(https://cdn.mindrocketsapis.com/client/Fonts/ma/MaterialIcons-Regular.ttf)",
      {
        style: "normal",
        weight: 400,
      }
    );

    font
      .load()
      .then(function () {
        document.fonts.add(font);
        jQuery(MrmainappendOnCustom).append(
          `<div class="${mrMainPalyerClassCustom.replace(".", "")}"> </div>`
        );
        MrNavPlayerSLAppendStyles();
        MrInjectNavPlayer(mrMainPalyerClassCustom);
        jQuery("#TranslateStop").click(function () {
          MrCloseSequence();
        });
      })
      .catch(function (err) {
        console.log(err);
      });
  }
}

function MrNavPlayerSLAppendStyles() {
  MrUAPAddStyleCustom(
    ".MrSLnarrator-icon {filter:" +
      MrUtilHexToFilterCustom(MrMUISecoundryColorCustom) +
      '; width: 34px !important;max-width: 34px !important;height: auto;cursor: pointer;content: url("https://cdn.mindrocketsapis.com/client/imgs/png/narrator%203.png"); } .MrSLnarrator-icon.Mrnactive {  content: url("https://cdn.mindrocketsapis.com/client/imgs/png/narrator%203_1.png"); }',
    "MrNatrratorCSSSL"
  );
  MrUAPAddStyleCustom(
    ":root {--mr-main-color:" +
      MrMUISecoundryColorCustom +
      ";--mr-sec-color:" +
      MrMUIPrimaryColorCustom +
      ";--mr-white-color:" +
      MrMUIWhiteCustom +
      ";--mr-black-color:" +
      MrMUIBlackCustom +
      ";}",
    "MrTtsRootSL"
  );

  MrUAPAddStyleCustom(
    "@media (max-width: 767px) {  #MrTTS {bottom :75px !important} .MrNavSLDiv {bottom : 150px !important ;transform: translate(0px, 0px) !important; }.mr-volume-slider-background {width:12vw !important; } .mr-material-sl-icons { font-size: 25px !important; font-family: 'MrMaterialSl Icons';font-weight: normal;font-style: normal; } .mr-volume-group {display :none !important}",
    "MrMUISmallScreenCSSSL"
  );

  MrUAPAddStyleCustom(
    ".mr-material-sl-icons { font-family: 'MrMaterialSl Icons'; font-weight: normal; font-style: normal; font-size: 24px; line-height: 1; letter-spacing: normal; text-transform: none; display: inline-block; white-space: nowrap; word-wrap: normal; direction: ltr; -webkit-font-smoothing: antialiased; }",
    "MrTtsMaterialIconsSL"
  );
  MrUAPAddStyleCustom(".mr-js-cycle {cursor : none !important}");

  MrUAPAddStyleCustom(
    ".mr-navsl-player { background-color:var(--mr-sec-color); padding-top: 2px; border-radius: 3px; border: 0px solid var(--mr-main-color); position: relative; user-select: none; color: var(--mr-main-color); width: max-content;     direction: ltr !important; } ",
    "MrTtsAudioPlayerSL"
  );

  MrUAPAddStyleCustom(
    '.mr-slnav-controls { display: flex; flex-wrap: wrap;padding-left: 3px; } .mr-slnav-controls button { padding: 2px; border: 0; background-color: transparent; color: inherit; font-size: inherit; line-height: inherit; display: inline-flex; align-items: center; } .left-mr-slnav-controls { display: flex; flex-grow: 1; align-items: center; } .right-mr-slnav-controls { display: flex; align-items: center; flex-wrap: wrap; } .mr-volume-group { display: flex; flex-grow: 0; align-items: center; } .mr-volume-slider-background { cursor: pointer; display: inline-block; width: 100px; background-color:var(--mr-white-color); margin-left: 5px; margin-bottom: 1px; margin-right: 13px; } .mr-volume-slider { pointer-events: none; position: relative; height: 8px; width: 100%; background-color:var(--mr-main-color); } .mr-volume-slider::after { content: ""; position: absolute; right: 0; top: 50%; transform: translate(50%, -50%); display: block; width: 12px; height: 12px; background-color:var(--mr-main-color); border-radius: 50%; z-index: 1; box-shadow: 0 0 3px rgba(0, 0, 0, 0.5); }',
    "MrAudioPlayerControlsSL"
  );

  MrUAPAddStyleCustom(
    '.mr-navsl-player button { cursor: pointer;     margin-right: 62px; vertical-align: middle; position: relative; } .mr-slnav-controls .replay-button {     margin-right: 30px; } .mr-material-sl-icons { font-size: 30px; } .mr-material-sl-icons-copy { font-size: 20px; } .mr-material-sl-icons-replayforward { font-size: 25px; } .mr-material-sl-icons-playbackspeed { font-size: 25px; margin-right: 2px; } .mr-material-sl-icons-volume { font-size: 28px; } .speed-text { font-family: "Roboto", sans-serif; }',
    "MrAudioPlayerControls2SL"
  );

  MrUAPAddStyleCustom(
    ".MrNavSLDiv {z-index: 99999999999;bottom: 260px; width: 260px ; height: max-content;right: 385px; padding: 5px; border-radius: 5px;background-color:" +
      MrMUISecoundryColorCustom +
      "}",
    "MrNavSLDivCSSSL"
  );
  MrUAPAddStyleCustom(
    ".MraudButton {background-color : " +
      MrMUIPrimaryColorCustom +
      " ; width:50px ; height: 50px}",
    "MRBackForwardSL"
  );
}
function MrUAPAddClassesCustom(element, classes) {
  var classNames = " ";
  for (let index = 0; index < classes.length; index++) {
    const element = classes[index];
    classNames += element + " ";
  }
  document.querySelectorAll(element).forEach((e) => {
    e.className += classNames;
  });
}
function MrUAPAddStyleCustom(style, id) {
  var styles = style;
  var elem = document.createElement("style");
  elem.innerHTML = styles;
  elem.id = id;
  document.body.appendChild(elem);
  MrUAPAddClassesCustom(id, "mr-tooltip-skip");
}
var mrInLoopPlay = false;
function mrPlaySequence() {
  if (jQuery(".mr-js-pause").is(":hidden")) {
    jQuery(".mr-js-pause").show();
    jQuery(".mr-js-play").hide();
    mrInLoopPlay = true;
    mrPlaySequenceBtn();
  }
}
var mrCurrentIndex = 0;
function mrPlaySequenceBtn() {
  if (mrCurrentIndex < MrGetArabotWindow().find(".mr-interp-btn").length) {
    MrTranslateTextInternal("");
    var BtntoPlay = MrGetArabotWindow().find(
      ".mr-interp-btn[mr-Btni=" + mrCurrentIndex + "]"
    );
    if ($(BtntoPlay).parent().find(".mr-interp-btn").length > 1) {
      $(BtntoPlay).parent().find(".mr-interp-btn:last").click();
      mrCurrentIndex = $(BtntoPlay)
        .parent()
        .find(".mr-interp-btn:last")
        .attr("mr-btni");
      return;
    }
    MrIsInTranslate = false;
    BtntoPlay[0].click();
  } else {
    mrPauseSequence();
  }
}
function mrPauseSequence() {
  if (jQuery(".mr-js-play").is(":hidden")) {
    jQuery(".mr-js-play").show();
    jQuery(".mr-js-pause").hide();
    mrInLoopPlay = false;
  }
}
function mrPrevSequence() {
  mrCurrentIndex--;
  if (mrCurrentIndex < 0) {
    mrCurrentIndex = 0;
  }
  mrPlaySequenceBtn();
}
function mrNextSequence() {
  mrCurrentIndex++;
  if (mrCurrentIndex >= MrGetArabotWindow().find(".mr-interp-btn").length) {
    mrCurrentIndex = MrGetArabotWindow().find(".mr-interp-btn").length - 1;
  }
  mrPlaySequenceBtn();
}

function MrCloseSequence() {
  jQuery(mrMainPalyerClassCustom).remove();
}
function MrInjectNavPlayer(mainDiv) {
  var MrPlayerHTML =
    '<div class="mr-js-mr-navsl-player mr-navsl-player mr-tooltip-readSkip skiptranslate">';
  MrPlayerHTML +=
    '  <audio class="mr-js-audio skiptranslate" id="mr-aud-play" preload="metadata">';
  MrPlayerHTML += '    <source id="mr-aud-src" src="" type="audio/mpeg" />';
  MrPlayerHTML += "  </audio>";
  MrPlayerHTML += " ";
  MrPlayerHTML +=
    '<div class="mr-slnav-controls mr-tooltip-readSkip skiptranslate">';
  MrPlayerHTML +=
    '  <div style="direction: ltr !important" class="left-mr-slnav-controls mr-tooltip-readSkip">';
  MrPlayerHTML +=
    '    <button class="mr-js-play skiptranslate"> <i class="mr-material-sl-icons skiptranslate">play_arrow</i> </button>';
  MrPlayerHTML +=
    '    <button class="mr-js-pause skiptranslate" style="display:none"> <i class="mr-material-sl-icons skiptranslate">pause</i> </button>';
  MrPlayerHTML +=
    '   <button class="mr-js-replay replay-button skiptranslate"> <i class="mr-material-sl-icons mr-material-sl-icons-replayforward skiptranslate"> arrow_back_ios </i> </button>  ';
  MrPlayerHTML +=
    ' <button class="mr-js-forward skiptranslate"> <i class="mr-material-sl-icons mr-material-sl-icons-replayforward skiptranslate"> arrow_forward_ios  </i> </button> ';
  MrPlayerHTML += "  </div>";
  MrPlayerHTML += "</div>";
  MrPlayerHTML += "</div>";
  jQuery(mainDiv).append(MrPlayerHTML);

  jQuery(".mr-js-play").click(mrPlaySequence);
  jQuery(".mr-js-pause").click(mrPauseSequence);
  jQuery(".mr-js-replay").click(mrPrevSequence);
  jQuery(".mr-js-forward").click(mrNextSequence);
}

class MrUtilColorCustom {
  constructor(MrColor) {
    this.set(MrColor.R, MrColor.G, MrColor.B);
  }

  toString() {
    return `rgb(${Math.round(this.r)}, ${Math.round(this.g)}, ${Math.round(
      this.b
    )})`;
  }

  set(r, g, b) {
    this.r = this.clamp(r);
    this.g = this.clamp(g);
    this.b = this.clamp(b);
  }

  hueRotate(angle = 0) {
    angle = (angle / 180) * Math.PI;
    const sin = Math.sin(angle);
    const cos = Math.cos(angle);

    this.multiply([
      0.213 + cos * 0.787 - sin * 0.213,
      0.715 - cos * 0.715 - sin * 0.715,
      0.072 - cos * 0.072 + sin * 0.928,
      0.213 - cos * 0.213 + sin * 0.143,
      0.715 + cos * 0.285 + sin * 0.14,
      0.072 - cos * 0.072 - sin * 0.283,
      0.213 - cos * 0.213 - sin * 0.787,
      0.715 - cos * 0.715 + sin * 0.715,
      0.072 + cos * 0.928 + sin * 0.072,
    ]);
  }

  grayscale(value = 1) {
    this.multiply([
      0.2126 + 0.7874 * (1 - value),
      0.7152 - 0.7152 * (1 - value),
      0.0722 - 0.0722 * (1 - value),
      0.2126 - 0.2126 * (1 - value),
      0.7152 + 0.2848 * (1 - value),
      0.0722 - 0.0722 * (1 - value),
      0.2126 - 0.2126 * (1 - value),
      0.7152 - 0.7152 * (1 - value),
      0.0722 + 0.9278 * (1 - value),
    ]);
  }

  sepia(value = 1) {
    this.multiply([
      0.393 + 0.607 * (1 - value),
      0.769 - 0.769 * (1 - value),
      0.189 - 0.189 * (1 - value),
      0.349 - 0.349 * (1 - value),
      0.686 + 0.314 * (1 - value),
      0.168 - 0.168 * (1 - value),
      0.272 - 0.272 * (1 - value),
      0.534 - 0.534 * (1 - value),
      0.131 + 0.869 * (1 - value),
    ]);
  }

  saturate(value = 1) {
    this.multiply([
      0.213 + 0.787 * value,
      0.715 - 0.715 * value,
      0.072 - 0.072 * value,
      0.213 - 0.213 * value,
      0.715 + 0.285 * value,
      0.072 - 0.072 * value,
      0.213 - 0.213 * value,
      0.715 - 0.715 * value,
      0.072 + 0.928 * value,
    ]);
  }

  multiply(matrix) {
    const newR = this.clamp(
      this.r * matrix[0] + this.g * matrix[1] + this.b * matrix[2]
    );
    const newG = this.clamp(
      this.r * matrix[3] + this.g * matrix[4] + this.b * matrix[5]
    );
    const newB = this.clamp(
      this.r * matrix[6] + this.g * matrix[7] + this.b * matrix[8]
    );
    this.r = newR;
    this.g = newG;
    this.b = newB;
  }

  brightness(value = 1) {
    this.linear(value);
  }
  contrast(value = 1) {
    this.linear(value, -(0.5 * value) + 0.5);
  }

  linear(slope = 1, intercept = 0) {
    this.r = this.clamp(this.r * slope + intercept * 255);
    this.g = this.clamp(this.g * slope + intercept * 255);
    this.b = this.clamp(this.b * slope + intercept * 255);
  }

  invert(value = 1) {
    this.r = this.clamp((value + (this.r / 255) * (1 - 2 * value)) * 255);
    this.g = this.clamp((value + (this.g / 255) * (1 - 2 * value)) * 255);
    this.b = this.clamp((value + (this.b / 255) * (1 - 2 * value)) * 255);
  }

  hsl() {
    // Code taken from https://stackoverflow.com/a/9493060/2688027, licensed under CC BY-SA.
    const r = this.r / 255;
    const g = this.g / 255;
    const b = this.b / 255;
    const max = Math.max(r, g, b);
    const min = Math.min(r, g, b);
    let h,
      s,
      l = (max + min) / 2;

    if (max === min) {
      h = s = 0;
    } else {
      const d = max - min;
      s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
      switch (max) {
        case r:
          h = (g - b) / d + (g < b ? 6 : 0);
          break;

        case g:
          h = (b - r) / d + 2;
          break;

        case b:
          h = (r - g) / d + 4;
          break;
      }
      h /= 6;
    }

    return {
      h: h * 100,
      s: s * 100,
      l: l * 100,
    };
  }

  clamp(value) {
    if (value > 255) {
      value = 255;
    } else if (value < 0) {
      value = 0;
    }
    return value;
  }
}
class MrUtilSolverCustom {
  constructor(target, baseColor) {
    this.target = target;
    this.targetHSL = target.hsl();
    this.reusedColor = new MrUtilColorCustom(0, 0, 0);
  }

  solve() {
    const result = this.solveNarrow(this.solveWide());
    return {
      values: result.values,
      loss: result.loss,
      filter: this.css(result.values),
    };
  }

  solveWide() {
    const A = 5;
    const c = 15;
    const a = [60, 180, 18000, 600, 1.2, 1.2];

    let best = { loss: Infinity };
    for (let i = 0; best.loss > 25 && i < 3; i++) {
      const initial = [50, 20, 3750, 50, 100, 100];
      const result = this.spsa(A, a, c, initial, 1000);
      if (result.loss < best.loss) {
        best = result;
      }
    }
    return best;
  }

  solveNarrow(wide) {
    const A = wide.loss;
    const c = 2;
    const A1 = A + 1;
    const a = [0.25 * A1, 0.25 * A1, A1, 0.25 * A1, 0.2 * A1, 0.2 * A1];
    return this.spsa(A, a, c, wide.values, 500);
  }

  spsa(A, a, c, values, iters) {
    const alpha = 1;
    const gamma = 0.16666666666666666;

    let best = null;
    let bestLoss = Infinity;
    const deltas = new Array(6);
    const highArgs = new Array(6);
    const lowArgs = new Array(6);

    for (let k = 0; k < iters; k++) {
      const ck = c / Math.pow(k + 1, gamma);
      for (let i = 0; i < 6; i++) {
        deltas[i] = Math.random() > 0.5 ? 1 : -1;
        highArgs[i] = values[i] + ck * deltas[i];
        lowArgs[i] = values[i] - ck * deltas[i];
      }

      const lossDiff = this.loss(highArgs) - this.loss(lowArgs);
      for (let i = 0; i < 6; i++) {
        const g = (lossDiff / (2 * ck)) * deltas[i];
        const ak = a[i] / Math.pow(A + k + 1, alpha);
        values[i] = fix(values[i] - ak * g, i);
      }

      const loss = this.loss(values);
      if (loss < bestLoss) {
        best = values.slice(0);
        bestLoss = loss;
      }
    }
    return { values: best, loss: bestLoss };

    function fix(value, idx) {
      let max = 100;
      if (idx === 2 /* saturate */) {
        max = 7500;
      } else if (idx === 4 /* brightness */ || idx === 5 /* contrast */) {
        max = 200;
      }

      if (idx === 3 /* hue-rotate */) {
        if (value > max) {
          value %= max;
        } else if (value < 0) {
          value = max + (value % max);
        }
      } else if (value < 0) {
        value = 0;
      } else if (value > max) {
        value = max;
      }
      return value;
    }
  }

  loss(filters) {
    // Argument is array of percentages.
    const color = this.reusedColor;
    color.set(0, 0, 0);

    color.invert(filters[0] / 100);
    color.sepia(filters[1] / 100);
    color.saturate(filters[2] / 100);
    color.hueRotate(filters[3] * 3.6);
    color.brightness(filters[4] / 100);
    color.contrast(filters[5] / 100);

    const colorHSL = color.hsl();
    return (
      Math.abs(color.r - this.target.r) +
      Math.abs(color.g - this.target.g) +
      Math.abs(color.b - this.target.b) +
      Math.abs(colorHSL.h - this.targetHSL.h) +
      Math.abs(colorHSL.s - this.targetHSL.s) +
      Math.abs(colorHSL.l - this.targetHSL.l)
    );
  }

  css(filters) {
    function fmt(idx, multiplier = 1) {
      return Math.round(filters[idx] * multiplier);
    }
    return `filter: invert(${fmt(0)}%) sepia(${fmt(1)}%) saturate(${fmt(
      2
    )}%) hue-rotate(${fmt(3, 3.6)}deg) brightness(${fmt(4)}%) contrast(${fmt(
      5
    )}%);`;
  }
}
function MrUtilHexToRGBCustom(hex) {
  // Expand shorthand form (e.g. "03F") to full form (e.g. "0033FF")
  const shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
  hex = hex.replace(shorthandRegex, (m, r, g, b) => {
    return r + r + g + g + b + b;
  });

  const result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
  return {
    R: parseInt(result[1], 16),
    G: parseInt(result[2], 16),
    B: parseInt(result[3], 16),
  };
}
function MrUtilHexToFilterCustom(hex, withoutPrefix = true) {
  const rgb = MrUtilHexToRGBCustom(hex);

  const color = new MrUtilColorCustom(rgb);
  const solver = new MrUtilSolverCustom(color);
  const result = solver.solve();

  return withoutPrefix
    ? result.filter.split(":")[1].split(";")[0]
    : result.filter;
}
